#ifdef FEATURE
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#if defined (_IBMR2) || defined(SYSV)
#include <time.h>
#endif				/* _IBMR2 */
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include <sys/time.h>
#include "prog_version.h"

#define TESTCAP(c,s)    (c ? strcap(s) : s)

static int                      version_sent = 0;
CheckFeatures(m)
   char                           *m;
{
   char                            buf[BUFSIZ];
   int			           features=0;

   strcpy(buf, "BRMH: Features enabled: ");

   if (strstr(m, "NO_NEWMACRO")) {
      F_UseNewMacro = 0;
      strcat(buf, "NO_NEWMACRO, ");
      features++;
   }
   if (strstr(m, "NO_SMARTMACRO")) {
      F_UseSmartMacro = 0;
      strcat(buf, "NO_SMARTMACRO, ");
      features++;
   }
   if (strstr(m, "WHY_DEAD")) {
      F_why_dead = 1;
      strcat(buf, "WHY_DEAD, ");
      features++;
   }
   if(!features) return;
   buf[strlen(buf)-2] = 0;

   W_WriteText(reviewWin, 0, 0, W_White, buf, strlen(buf), 0);
   W_WriteText(messwa, 0, 0, W_White, buf, strlen(buf), 0);
}

sendVersion()
{
   char                            client_ver[15];
   if (!version_sent) {
      version_sent = 1;
      sprintf(client_ver, "@%s.%d", VERSION, PATCHLEVEL);

      sendMessage(client_ver, MINDIV|MCONFIG, me->p_no);
   }
}

/* return a pointer to a capitalized copy of string s */
char *strcap(s)
char *s;
{
   static char		buf[256];	/* returns static */
   register char	*t = buf;

   while(*s){
      if(islower(*s))
	 *t++ = toupper(*s++);
      else
	 *t++ = *s++;
   }
   *t = 0;
   if(buf[255]) {
      fprintf(stderr, "ERROR: String constant overwritten\n");
      return NULL;
   }
   return buf;
}

doMacro(key, data)

   int          key;
   W_Event	*data;
{
   int   	found = 0;
   register	c;
   struct obtype *gettarget(), *target = NULL;
   char		who;
   int		targettype;

   if (key == '?') {
      showMacroWin();
   } else {
      if (F_UseNewMacro) {
/* sorry guys, I only program in kludge - jn 6/3/93 */
	 if (MacroNum > -1) {	/* macro identified, who to? */
	    if (MacroNum >= MAX_MACRO)
	       fprintf(stderr, "Unknown macro number %d.\n", MacroNum);
	    if (!pmacro(MacroNum, key, data))
	       W_Beep();

	    MacroMode = 0;
	    MacroNum = -1;
	    return (0);
	 }
      }
      for (c = 0; c < macrocnt; c++) {
	 if (macro[c].key == key) {
	    found = 1;
	    if (F_UseNewMacro) {
	       switch (macro[c].type) {
	       case NBTM:
		  pnbtmacro(c);
		  break;
	       case NEWM:
		  MacroNum = c;
		  return (0);
		  break;
	       case NEWMMOUSE:
                    /* first translate into who, then send */
		  switch (macro[c].who) {

		     struct player *j;
		     struct planet* l;

		     case MACRO_FRIEND:
		     case MACRO_ENEMY:
                     case MACRO_PLAYER:
			targettype = TARG_PLAYER;
                        if (macro[c].who == MACRO_ENEMY)
			   targettype |= TARG_ENEMY;
                        else if (macro[c].who == MACRO_FRIEND)
			   targettype |= TARG_FRIEND;

			target = gettarget(data->Window, data->x, data->y,
                        		   TARG_PLAYER|TARG_CLOAK);
                        if (target->o_type == PLAYERTYPE) {
			   j = &players[target->o_num];
			   if(j->p_flags & PFCLOAK) maskrecip = 1;
			   who = j->p_mapchars[1];
                        }
                        else {
			   who = me->p_mapchars[1];
			   warning("Can only send a message to a player");
                        }
                        break;
		     case MACRO_TEAM:
			target = gettarget(data->Window, data->x, data->y,
                        		   TARG_PLAYER|TARG_PLANET);
                        if (target->o_type == PLANETTYPE) {
			   l = &planets[target->o_num];
			   who = teamlet[l->pl_owner];
                        }
                        else if (target->o_type == PLAYERTYPE) {
			   j = &players[target->o_num];
			   who = j->p_mapchars[0];
                        }
                        else {
			   who = me->p_mapchars[1];
			   warning("Player or planet only please");
                        }
                        break;
		     default:
                         who = me->p_mapchars[1];
                         break;
		  }
		  if (!pmacro(c,who,data))
		     W_Beep();
		  break;

	       case NEWMSPEC:
		  if (!pmacro(c, macro[c].who, data))
		     W_Beep();
		  break;
	       default:
		  fprintf(stderr, "Unknown macro type %d.\n", macro[c].type);
		  break;
	       }
	    } else {
	       pnbtmacro(c);
	    }
	 }
      }
      if (!found) {
	 W_Beep();
	 warning(" ");		/* clear warning message */
      }
   }

   MacroMode = 0;
   if (F_UseNewMacro)
      MacroNum = -1;
   return (0);

}

/* Used in NEWMACRO, useful elsewhere also */
int 
getgroup(addr, recip)
   char                            addr;
   int                            *recip;
{
   *recip = 0;

   switch (addr) {
   case 'A':
      *recip = 0;
      return (MALL);
      break;
   case 'F':
      *recip = FED;
      return (MTEAM);
      break;
   case 'R':
      *recip = ROM;
      return (MTEAM);
      break;
   case 'K':
      *recip = KLI;
      return (MTEAM);
      break;
   case 'O':
      *recip = ORI;
      return (MTEAM);
      break;
   case 'G':
      *recip = 0;
      return (MGOD);
      break;
   case '0':
   case '1':
   case '2':
   case '3':
   case '4':
   case '5':
   case '6':
   case '7':
   case '8':
   case '9':
      if (players[addr - '0'].p_status == PFREE) {
	 warning("That player left the game. message not sent.");
	 return 0;
      }
      *recip = addr - '0';
      return (MINDIV);
      break;
   case 'a':
   case 'b':
   case 'c':
   case 'd':
   case 'e':
   case 'f':
   case 'g':
   case 'h':
   case 'i':
   case 'j':
   case 'k':
   case 'l':
   case 'm':
   case 'n':
   case 'o':
   case 'p':
   case 'q':
   case 'r':
   case 's':
   case 't':
   case 'u':
   case 'v':
   case 'w':
   case 'x':
   case 'y':
   case 'z':
      if (players[addr - 'a' + 10].p_status == PFREE) {
	 warning("That player left the game. message not sent.");
	 return 0;
      }
      *recip = addr - 'a' + 10;
      return (MINDIV);
      break;
   default:
      warning("Not legal recipient");
   }
   return 0;
}


pnbtmacro(c)
   int                             c;
{
   switch (macro[c].who) {
   case 'A':
      pmessage(macro[c].string, 0, MALL);
      break;
   case 'F':
      pmessage(macro[c].string, FED, MTEAM);
      break;
   case 'R':
      pmessage(macro[c].string, ROM, MTEAM);
      break;
   case 'K':
      pmessage(macro[c].string, KLI, MTEAM);
      break;
   case 'O':
      pmessage(macro[c].string, ORI, MTEAM);
      break;
   case 'T':
      pmessage(macro[c].string, me->p_team, MTEAM);
      break;
   }
}

/* the primary subroutine for newmacro, converts the strange and wonderful
** newmacro syntax into an actual message.
** This is about as inefficient as they come, but how often is the player
** going to send a macro??
**  6/3/93 - jn
*/

pmacro(mnum, who, data)
   int                             mnum;
   char                            who;
   W_Event                        *data;
{
   char                            buf1[10 * MAXMACLEN];
   char                            buf2[10 * MAXMACLEN];
   char                            buf3[10 * MAXMACLEN];
   char                            tmp[MAXMACLEN];
   char                           *pm;
   char                           *pbuf2;
   char                            ctmp;
   int                             index = 0;
   int                             index2 = 0;
   int                             index3 = 0;
   int                             recip;
   int                             group;
   char                           *getaddr();
   char                            addr;
   char                           *addr_str;
   int                             state = 0, cap = 0, team=0;
   struct player                  *j;
   struct planet                  *l;
   struct obtype                  *gettarget(), *gettarget2(), *target;
   int				   targettype = 0;
   char                           *pos;
#ifdef PING
   extern int ping_iloss_sc;       /* inc % loss 0--100, server to client */
   extern int ping_iloss_cs;       /* inc % loss 0--100, client to server */
   extern int ping_tloss_sc;       /* total % loss 0--100, server to client */
   extern int ping_tloss_cs;       /* total % loss 0--100, client to server */
   extern int ping_lag;            /* delay in ms of last ping */
   extern int ping_av;             /* average rt */
   extern int ping_sd;             /* standard deviation */
#endif

   if (!F_UseNewMacro)
      return 0;

   /* get recipient and group */
   if ((who == 't') || (who == 'T'))
      addr = teamlet[me->p_team];
   else
      addr = who;

   group = getgroup(addr, &recip);

   if (!group) {
      fprintf(stderr, "Bad group in address \"%c\"\n", addr);
      return (0);
   }
   pm = macro[mnum].string;

   buf1[0] = '\0';

   /* first step is to substitute variables */
   while (*pm) {
      if (state) {
	 switch (*(pm++)) {
	 case 'a':		/* push army number into buf */
	    sprintf(tmp, "%d", me->p_armies);
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'd':		/* push damage into buf */
	    sprintf(tmp, "%d", (100 * me->p_damage) / me->p_ship.s_maxdamage);
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	 case 's':		/* push shields into buf */
	    sprintf(tmp, "%d", (100 * me->p_shield) / me->p_ship.s_maxshield);
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	    break;
	 case 'f':		/* push fuel into buf */
	    sprintf(tmp, "%d", (100 * me->p_fuel) / me->p_ship.s_maxfuel);
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'w':		/* push wtemp into buf */
	    sprintf(tmp, "%d", (100 * me->p_wtemp) / me->p_ship.s_maxwpntemp);
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'e':		/* push etemp into buf */
	    sprintf(tmp, "%d", (100 * me->p_etemp) / me->p_ship.s_maxegntemp);
	    sprintf(tmp, "%d", me->p_armies);
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'p':		/* push player id into buf */
	    targettype = TARG_PLAYER;
	 case 'g':
	    if(!targettype) targettype = TARG_FRIEND;
	 case 'h':
	    if(!targettype) targettype = TARG_ENEMY;

	    target = gettarget(data->Window, data->x, data->y,
			       targettype);
	    if(target->o_type == PLAYERTYPE) {
	       j = &players[target->o_num];
	       tmp[0] = j->p_mapchars[1];
	       tmp[1] = '\0';
	       strcat(buf1, tmp);
	    }

	    targettype = 0;
	    state = 0;
	    continue;
	    break;

	 case 'n':		/* push planet armies into buf */
	    target = gettarget(data->Window, data->x, data->y,
			       TARG_PLANET);
	    if (target->o_type == PLANETTYPE) {
	       l = &planets[target->o_num];
	       if (l->pl_info & me->p_team)
		  sprintf(tmp, "%d", l->pl_armies);
	       else
		  sprintf(tmp, "%d", -1);
	       strcat(buf1, tmp);
	    }
	    state = 0;
	    continue;
	    break;
	 case 'B':
	    cap = 1;
         case 'b':       /* push planet into buf */
            target = gettarget2(me->p_x, me->p_y, TARG_PLANET);
            if (target->o_type == PLANETTYPE) {
	       l = &planets[target->o_num];
               tmp[0] = l->pl_name[0] - 'A' + 'a';
               tmp[1] = l->pl_name[1];
               tmp[2] = l->pl_name[2];
               tmp[3] = '\0';
               strcat(buf1,TESTCAP(cap,tmp));
            }
            cap = 0;
            state = 0;
            continue;
            break;

	 case 'L':
	    cap = 1;
	 case 'l':		/* push planet into buf */
	    target = gettarget(data->Window, data->x, data->y,
			       TARG_PLANET);
	    if (target->o_type == PLANETTYPE) {
	       l = &planets[target->o_num];
	       tmp[0] = l->pl_name[0] - 'A' + 'a';
	       tmp[1] = l->pl_name[1];
	       tmp[2] = l->pl_name[2];
	       tmp[3] = '\0';
	       strcat(buf1, TESTCAP(cap, tmp));
	    }
	    cap = 0;
	    state = 0;
	    continue;
	    break;
	 case 'Z':       /* push a 3 character team name into buf */
	    cap = 1;
         case 'z':       /* push a 3 character team name into buf */
	    target = gettarget(data->Window, data->x, data->y,
	    		       TARG_PLAYER|TARG_PLANET);
            if (target->o_type == PLANETTYPE) {
	       l = &planets[target->o_num];
	       team = l->pl_owner;
            }
            else if (target->o_type == PLAYERTYPE) {
	       j = &players[target->o_num];
	       team = j->p_team;
            }
            else
	       team = 3;/* send "X", might just make the guy correct it*/
            strcat(buf1,TESTCAP(cap,teamshort[team]));
            state = 0;
            cap = 0;
            continue;
            break;

	 case 't':		/* push a team into buf */
	    target = gettarget(data->Window, data->x, data->y,
			       TARG_PLAYER | TARG_PLANET);
	    if (target->o_type == PLANETTYPE) {
	       l = &planets[target->o_num];
	       tmp[0] = teamlet[l->pl_owner];
	    } else if (target->o_type == PLAYERTYPE) {
	       j = &players[target->o_num];
	       tmp[0] = j->p_mapchars[0];
	    } else
	       tmp[0] = '\0';
	    tmp[1] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'T':		/* push my team into buf */
	    tmp[0] = me->p_mapchars[0];
	    tmp[1] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'c':		/* push my id char into buf */
	    tmp[0] = me->p_mapchars[1];
	    tmp[1] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'W':		/* push WTEMP flag into buf */
	    if (me->p_flags & PFWEP)
	       tmp[0] = '1';
	    else
	       tmp[0] = '0';
	    tmp[1] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'E':		/* push ETEMP flag into buf */
	    if (me->p_flags & PFENG)
	       tmp[0] = '1';
	    else
	       tmp[0] = '0';
	    tmp[1] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case 'M':		/* push lastMessage into buf */
	    cap = 1;
	 case 'm':		/* push lastMessage into buf */
	    strncat(buf1, lastMessage, 79);
	    state = 0;
	    cap = 0;
	    continue;
	    break;
	 case 'U':       /* push player name into buf */
	    cap = 1;
         case 'u':       /* push player name into buf */
	    target = gettarget(data->Window, data->x, data->y,
            		       TARG_PLAYER);
            j = &players[target->o_num];
            strncat(buf1,TESTCAP(cap,j->p_name),16);
            state = 0;
            cap = 0;
            continue;
            break;
	 case 'I':       /* my player name into buf */
	    cap = 1;
         case 'i':       /* my player name into buf */
            strncat(buf1,TESTCAP(cap,me->p_name),16);
            state = 0;
            cap = 0;
            continue;
            break;
	 case 'S':		/* push ship type into buf */
	    strcat(buf1, classes[me->p_ship.s_type]);
	    state = 0;
	    continue;
	    break;
#ifdef PING
         case 'v':       /* push average ping round trip time into buf */
	    sprintf(tmp,"%d",ping_av);
            strcat(buf1,tmp);
            state = 0;
            continue;
            break;
         case 'V':       /* push ping stdev into buf */
            sprintf(tmp,"%d",ping_sd);
            strcat(buf1,tmp);
            state = 0;
            continue;
            break;
         case 'y':       /* push packet loss into buf */
            /* this is the weighting formula used be socket.c ntserv */
            sprintf(tmp,"%d",(2*ping_tloss_sc + ping_tloss_cs)/3);
            strcat(buf1,tmp);
            state = 0;
            continue;
#endif

	 case '}':		/* push %} into buf */
	    tmp[0] = '%';
	    tmp[1] = '}';
	    tmp[2] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case '{':		/* push %{ into buf */
	    tmp[0] = '%';
	    tmp[1] = '{';
	    tmp[2] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case '!':		/* push %! into buf */
	    tmp[0] = '%';
	    tmp[1] = '!';
	    tmp[2] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case '?':		/* push %? into buf */
	    tmp[0] = '%';
	    tmp[1] = '?';
	    tmp[2] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 case '%':		/* push %% into buf */
	    tmp[0] = '%';
	    if (F_UseSmartMacro)
	       tmp[1] = '%';
	    tmp[2] = '\0';
	    strcat(buf1, tmp);
	    state = 0;
	    continue;
	    break;
	 default:
	    warning("Bad Macro character in macro.");
	    fprintf(stderr, 
	       "Unrecognizable special character in macro pass 1: %c\n", *pm);
	    return (0);
	 }
      }
      if (*pm == '%') {
	 state++;
	 pm++;
	 continue;
      }
      state = 0;

      tmp[0] = *pm;
      tmp[1] = '\0';
      strcat(buf1, tmp);
      pm++;
   }

   if (!F_UseSmartMacro) {
      pmessage(buf1, recip, group);
   } else {
      /* second step is to evaluate tests, buf1->buf2 */
      testmacro(buf1, buf2, &index, &index2);
      buf2[index2] = '\0';

      index2 = 0;

      /* third step is to include conditional text, buf2->buf3 */
      condmacro(buf2, buf3, &index2, &index3, 1);
      buf3[index3] = '\0';

      pmessage(buf3, recip, group);
   }
   return 1;
}

testmacro(bufa, bufb, inda, indb)
   char                           *bufa;
   char                           *bufb;
   int                            *inda;
   int                            *indb;
{
   int                             state = 0;
   if (*indb >= 10 * MAXMACLEN)
      return;

   while (bufa[*inda] && (*indb < 10 * MAXMACLEN)) {
      if (state) {
	 switch (bufa[(*inda)++]) {
	 case '%':		/* push %% into buf */
	    if (*indb < 10 * MAXMACLEN - 2) {
	       bufb[*indb] = '%';
	       (*indb)++;
	       bufb[*indb] = '%';
	       (*indb)++;
	    } else
	       return (0);	/* we are full, so we are done */
	    state = 0;
	    continue;
	    break;

	 case '{':		/* push %{ into buf */
	    if (*indb < 10 * MAXMACLEN - 2) {
	       bufb[*indb] = '%';
	       (*indb)++;
	       bufb[*indb] = '{';
	       (*indb)++;
	    } else
	       return (0);	/* we are full, so we are done */
	    state = 0;
	    continue;
	    break;

	 case '}':		/* push %} into buf */
	    if (*indb < 10 * MAXMACLEN - 2) {
	       bufb[*indb] = '%';
	       (*indb)++;
	       bufb[*indb] = '}';
	       (*indb)++;
	    } else
	       return (0);	/* we are full, so we are done */
	    state = 0;
	    continue;
	    break;

	 case '!':		/* push %! into buf */
	    if (*indb < 10 * MAXMACLEN - 2) {
	       bufb[*indb] = '%';
	       (*indb)++;
	       bufb[*indb] = '!';
	       (*indb)++;
	    } else
	       return (0);	/* we are full, so we are done */
	    state = 0;
	    continue;
	    break;

	 case '?':		/* the dreaded conditional, evaluate it */
	    bufb[*indb] = '0' + solvetest(bufa, inda);
	    (*indb)++;
	    state = 0;
	    continue;
	    break;

	 default:
	    warning("Bad character in Macro!");
	    fprintf(stderr, 
"Unrecognizable special character in macro pass2: %c  Trying to continue.\n",
		   bufa[(*inda) - 1]);
	 }
      }
      if (bufa[*inda] == '%') {
	 state++;
	 (*inda)++;
	 continue;
      }
      state = 0;

      if (*indb < 10 * MAXMACLEN) {
	 bufb[*indb] = bufa[*inda];
	 (*inda)++;
	 (*indb)++;
      } else
	 return (0);
   }
}

solvetest(bufa, inda)
   char                           *bufa;
   int                            *inda;
{
   int                             state = 0;
   char                            bufh[10 * MAXMACLEN];
   char                            bufc[10 * MAXMACLEN];
   int                             indh = 0, indc = 0,
                                   i;
   char                            operation;

   while (bufa[*inda] &&
	  bufa[*inda] != '<' &&
	  bufa[*inda] != '>' &&
	  bufa[*inda] != '=') {

      bufh[indh++] = bufa[(*inda)++];
   }
   bufh[indh] = '\0';

   operation = bufa[(*inda)++];

   while (bufa[*inda] &&
	  !(state &&
	    ((bufa[*inda] == '?') ||
	     (bufa[*inda] == '{')))) {

      if (state && (bufa[*inda] == '%' ||
		    bufa[*inda] == '!' ||
		    bufa[*inda] == '}')) {
	 bufc[indc++] = '%';
      } else if (bufa[*inda] == '%') {
	 state = 1;
	 (*inda)++;
	 continue;
      }
      state = 0;
      bufc[indc++] = bufa[(*inda)++];
   }
   bufc[indc] = '\0';

   if (bufa[*inda])
      (*inda)--;

   if (!operation)		/* incomplete is truth, just ask Godel */
      return (1);

   switch (operation) {
   case '=':			/* character by character equality */
      if (indc != indh)
	 return (0);
      for (i = 0; i < indc; i++) {
	 if (bufc[i] != bufh[i])
	    return (0);
      }
      return (1);
      break;

   case '<':
      if (atoi(bufh) < atoi(bufc))
	 return (1);
      else
	 return (0);
      break;

   case '>':
      if (atoi(bufh) > atoi(bufc))
	 return (1);
      else
	 return (0);
      break;

   default:
      warning("Bad operation in Macro!");
      fprintf(stderr, "Unrecognizable operation in macro pass3: %c  Trying to continue.\n",
	     operation);
      return (1);		/* don't know what happened, pretend we do */
   }
}

condmacro(bufa, bufb, inda, indb, flag)
   char                           *bufa;
   char                           *bufb;
   int                            *inda;
   int                            *indb;
   int                             flag;
{
   int                             newflag, include;
   int                             state = 0;

   if (*indb >= MAXMACLEN)
      return;

   include = flag;

   while (bufa[*inda] && (*indb < MAXMACLEN)) {
      if (state) {
	 switch (bufa[(*inda)++]) {
	 case '}':		/* done with this conditional, return */
	    return (0);
	    break;

	 case '{':		/* handle new conditional */
	    if (*indb > 0) {
	       (*indb)--;
	       if (bufb[*indb] == '0')
		  newflag = 0;
	       else
		  newflag = 1;
	    } else		/* moron starting with cond, assume true */
	       newflag = 1;

	    if (include)
	       condmacro(bufa, bufb, inda, indb, newflag);
	    else
	       *inda = skipmacro(bufa, *inda);

	    state = 0;
	    continue;
	    break;

	 case '!':		/* handle not indicator */
	    if (flag)
	       include = 0;
	    else
	       include = 1;

	    state = 0;
	    continue;
	    break;

	 case '%':		/* push % into buf */
	    if (include) {
	       if (*indb < MAXMACLEN) {
		  bufb[*indb] = '%';
		  (*indb)++;
	       } else
		  return (0);
	    }
	    state = 0;
	    continue;

	 default:
	    warning("Bad character in Macro!");
	    fprintf(stderr, "Unrecognizable special character in macro pass4: %c  Trying to continue.\n",
		   bufa[(*inda) - 1]);
	 }
      }
      if (bufa[*inda] == '%') {
	 state++;
	 (*inda)++;
	 continue;
      }
      state = 0;


      if (include) {
	 if (*indb < MAXMACLEN) {
	    bufb[*indb] = bufa[*inda];
	    (*inda)++;
	    (*indb)++;
	 } else
	    return (0);
      } else
	 (*inda)++;
   }
}

skipmacro(buf, index)
   char                            buf[];
   int                             index;
{
   int                             state = 0;
   int                             end = 0;
   if (index == 0)
      index++;

   while (buf[index] && !end) {
      if (state) {
	 switch (buf[index++]) {
	 case '{':
	    index = skipmacro(buf, index);
	    continue;
	    break;
	 case '}':
	    end = 1;
	    continue;
	    break;
	 case '!':
	 case '%':
	    state = 0;
	    continue;
	    break;
	 default:
	    warning("Bad character in Macro!");
	    printf("Unrecognizable special character in macro pass5: %c  Trying to continue.\n",
		   buf[index]);
	 }
      }
      if (buf[index] == '%') {
	 state++;
	 index++;
	 continue;
      }
      state = 0;
      index++;
   }

   return (index);
}
#endif
